<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckQuoteResult StructType
 * @subpackage Structs
 */
class CheckQuoteResult extends AbstractStructBase
{
    /**
     * The CheckAvailabilityPms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $CheckAvailabilityPms;
    /**
     * The CheckAvailabilitySh
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $CheckAvailabilitySh;
    /**
     * The PmsAlternativeSuggestion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProductInformations
     */
    public $PmsAlternativeSuggestion;
    /**
     * The ShAlternativeSuggestion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProductInformations
     */
    public $ShAlternativeSuggestion;
    /**
     * The QuoteSh
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ProductInformations
     */
    public $QuoteSh;
    /**
     * Constructor method for CheckQuoteResult
     * @uses CheckQuoteResult::setCheckAvailabilityPms()
     * @uses CheckQuoteResult::setCheckAvailabilitySh()
     * @uses CheckQuoteResult::setPmsAlternativeSuggestion()
     * @uses CheckQuoteResult::setShAlternativeSuggestion()
     * @uses CheckQuoteResult::setQuoteSh()
     * @param bool $checkAvailabilityPms
     * @param bool $checkAvailabilitySh
     * @param \ArrayType\ArrayOfProductInformations $pmsAlternativeSuggestion
     * @param \ArrayType\ArrayOfProductInformations $shAlternativeSuggestion
     * @param \StructType\ProductInformations $quoteSh
     */
    public function __construct($checkAvailabilityPms = null, $checkAvailabilitySh = null, \ArrayType\ArrayOfProductInformations $pmsAlternativeSuggestion = null, \ArrayType\ArrayOfProductInformations $shAlternativeSuggestion = null, \StructType\ProductInformations $quoteSh = null)
    {
        $this
            ->setCheckAvailabilityPms($checkAvailabilityPms)
            ->setCheckAvailabilitySh($checkAvailabilitySh)
            ->setPmsAlternativeSuggestion($pmsAlternativeSuggestion)
            ->setShAlternativeSuggestion($shAlternativeSuggestion)
            ->setQuoteSh($quoteSh);
    }
    /**
     * Get CheckAvailabilityPms value
     * @return bool
     */
    public function getCheckAvailabilityPms()
    {
        return $this->CheckAvailabilityPms;
    }
    /**
     * Set CheckAvailabilityPms value
     * @param bool $checkAvailabilityPms
     * @return \StructType\CheckQuoteResult
     */
    public function setCheckAvailabilityPms($checkAvailabilityPms = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkAvailabilityPms) && !is_bool($checkAvailabilityPms)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($checkAvailabilityPms, true), gettype($checkAvailabilityPms)), __LINE__);
        }
        $this->CheckAvailabilityPms = $checkAvailabilityPms;
        return $this;
    }
    /**
     * Get CheckAvailabilitySh value
     * @return bool
     */
    public function getCheckAvailabilitySh()
    {
        return $this->CheckAvailabilitySh;
    }
    /**
     * Set CheckAvailabilitySh value
     * @param bool $checkAvailabilitySh
     * @return \StructType\CheckQuoteResult
     */
    public function setCheckAvailabilitySh($checkAvailabilitySh = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkAvailabilitySh) && !is_bool($checkAvailabilitySh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($checkAvailabilitySh, true), gettype($checkAvailabilitySh)), __LINE__);
        }
        $this->CheckAvailabilitySh = $checkAvailabilitySh;
        return $this;
    }
    /**
     * Get PmsAlternativeSuggestion value
     * @return \ArrayType\ArrayOfProductInformations|null
     */
    public function getPmsAlternativeSuggestion()
    {
        return $this->PmsAlternativeSuggestion;
    }
    /**
     * Set PmsAlternativeSuggestion value
     * @param \ArrayType\ArrayOfProductInformations $pmsAlternativeSuggestion
     * @return \StructType\CheckQuoteResult
     */
    public function setPmsAlternativeSuggestion(\ArrayType\ArrayOfProductInformations $pmsAlternativeSuggestion = null)
    {
        $this->PmsAlternativeSuggestion = $pmsAlternativeSuggestion;
        return $this;
    }
    /**
     * Get ShAlternativeSuggestion value
     * @return \ArrayType\ArrayOfProductInformations|null
     */
    public function getShAlternativeSuggestion()
    {
        return $this->ShAlternativeSuggestion;
    }
    /**
     * Set ShAlternativeSuggestion value
     * @param \ArrayType\ArrayOfProductInformations $shAlternativeSuggestion
     * @return \StructType\CheckQuoteResult
     */
    public function setShAlternativeSuggestion(\ArrayType\ArrayOfProductInformations $shAlternativeSuggestion = null)
    {
        $this->ShAlternativeSuggestion = $shAlternativeSuggestion;
        return $this;
    }
    /**
     * Get QuoteSh value
     * @return \StructType\ProductInformations|null
     */
    public function getQuoteSh()
    {
        return $this->QuoteSh;
    }
    /**
     * Set QuoteSh value
     * @param \StructType\ProductInformations $quoteSh
     * @return \StructType\CheckQuoteResult
     */
    public function setQuoteSh(\StructType\ProductInformations $quoteSh = null)
    {
        $this->QuoteSh = $quoteSh;
        return $this;
    }
}
