<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetStartingFromPriceFile StructType
 * @subpackage Structs
 */
class GetStartingFromPriceFile extends AbstractStructBase
{
    /**
     * The lang
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $lang;
    /**
     * The User
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WSUser
     */
    public $User;
    /**
     * The Tag
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Tag;
    /**
     * Constructor method for GetStartingFromPriceFile
     * @uses GetStartingFromPriceFile::setLang()
     * @uses GetStartingFromPriceFile::setUser()
     * @uses GetStartingFromPriceFile::setTag()
     * @param string $lang
     * @param \StructType\WSUser $user
     * @param string $tag
     */
    public function __construct($lang = null, \StructType\WSUser $user = null, $tag = null)
    {
        $this
            ->setLang($lang)
            ->setUser($user)
            ->setTag($tag);
    }
    /**
     * Get lang value
     * @return string
     */
    public function getLang()
    {
        return $this->lang;
    }
    /**
     * Set lang value
     * @uses \EnumType\Lang::valueIsValid()
     * @uses \EnumType\Lang::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $lang
     * @return \StructType\GetStartingFromPriceFile
     */
    public function setLang($lang = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Lang::valueIsValid($lang)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Lang', is_array($lang) ? implode(', ', $lang) : var_export($lang, true), implode(', ', \EnumType\Lang::getValidValues())), __LINE__);
        }
        $this->lang = $lang;
        return $this;
    }
    /**
     * Get User value
     * @return \StructType\WSUser|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param \StructType\WSUser $user
     * @return \StructType\GetStartingFromPriceFile
     */
    public function setUser(\StructType\WSUser $user = null)
    {
        $this->User = $user;
        return $this;
    }
    /**
     * Get Tag value
     * @return string|null
     */
    public function getTag()
    {
        return $this->Tag;
    }
    /**
     * Set Tag value
     * @param string $tag
     * @return \StructType\GetStartingFromPriceFile
     */
    public function setTag($tag = null)
    {
        // validation for constraint: string
        if (!is_null($tag) && !is_string($tag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tag, true), gettype($tag)), __LINE__);
        }
        $this->Tag = $tag;
        return $this;
    }
}
