<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for secureHolidayProductAvailabilitySpecifications StructType
 * @subpackage Structs
 */
class SecureHolidayProductAvailabilitySpecifications extends AbstractStructBase
{
    /**
     * The uniqueStayId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $uniqueStayId;
    /**
     * The pmark
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $pmark;
    /**
     * The PMS_Flag
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PMS_Flag;
    /**
     * The isSolution
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $isSolution;
    /**
     * The HasCancelDynamicConditions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $HasCancelDynamicConditions;
    /**
     * The uniqueStayIdTemp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $uniqueStayIdTemp;
    /**
     * The uniqueStayIdTemp2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $uniqueStayIdTemp2;
    /**
     * The ELC
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ELC;
    /**
     * The NS
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NS;
    /**
     * The tac
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $tac;
    /**
     * The spec
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $spec;
    /**
     * The crcChoosenOptions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $crcChoosenOptions;
    /**
     * The mo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mo;
    /**
     * The OSmark
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $OSmark;
    /**
     * The bookingAlert
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $bookingAlert;
    /**
     * Constructor method for secureHolidayProductAvailabilitySpecifications
     * @uses SecureHolidayProductAvailabilitySpecifications::setUniqueStayId()
     * @uses SecureHolidayProductAvailabilitySpecifications::setPmark()
     * @uses SecureHolidayProductAvailabilitySpecifications::setPMS_Flag()
     * @uses SecureHolidayProductAvailabilitySpecifications::setIsSolution()
     * @uses SecureHolidayProductAvailabilitySpecifications::setHasCancelDynamicConditions()
     * @uses SecureHolidayProductAvailabilitySpecifications::setUniqueStayIdTemp()
     * @uses SecureHolidayProductAvailabilitySpecifications::setUniqueStayIdTemp2()
     * @uses SecureHolidayProductAvailabilitySpecifications::setELC()
     * @uses SecureHolidayProductAvailabilitySpecifications::setNS()
     * @uses SecureHolidayProductAvailabilitySpecifications::setTac()
     * @uses SecureHolidayProductAvailabilitySpecifications::setSpec()
     * @uses SecureHolidayProductAvailabilitySpecifications::setCrcChoosenOptions()
     * @uses SecureHolidayProductAvailabilitySpecifications::setMo()
     * @uses SecureHolidayProductAvailabilitySpecifications::setOSmark()
     * @uses SecureHolidayProductAvailabilitySpecifications::setBookingAlert()
     * @param int $uniqueStayId
     * @param int $pmark
     * @param int $pMS_Flag
     * @param int $isSolution
     * @param bool $hasCancelDynamicConditions
     * @param int $uniqueStayIdTemp
     * @param int $uniqueStayIdTemp2
     * @param string $eLC
     * @param string $nS
     * @param string $tac
     * @param string $spec
     * @param string $crcChoosenOptions
     * @param string $mo
     * @param string $oSmark
     * @param string $bookingAlert
     */
    public function __construct($uniqueStayId = null, $pmark = null, $pMS_Flag = null, $isSolution = null, $hasCancelDynamicConditions = null, $uniqueStayIdTemp = null, $uniqueStayIdTemp2 = null, $eLC = null, $nS = null, $tac = null, $spec = null, $crcChoosenOptions = null, $mo = null, $oSmark = null, $bookingAlert = null)
    {
        $this
            ->setUniqueStayId($uniqueStayId)
            ->setPmark($pmark)
            ->setPMS_Flag($pMS_Flag)
            ->setIsSolution($isSolution)
            ->setHasCancelDynamicConditions($hasCancelDynamicConditions)
            ->setUniqueStayIdTemp($uniqueStayIdTemp)
            ->setUniqueStayIdTemp2($uniqueStayIdTemp2)
            ->setELC($eLC)
            ->setNS($nS)
            ->setTac($tac)
            ->setSpec($spec)
            ->setCrcChoosenOptions($crcChoosenOptions)
            ->setMo($mo)
            ->setOSmark($oSmark)
            ->setBookingAlert($bookingAlert);
    }
    /**
     * Get uniqueStayId value
     * @return int
     */
    public function getUniqueStayId()
    {
        return $this->uniqueStayId;
    }
    /**
     * Set uniqueStayId value
     * @param int $uniqueStayId
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setUniqueStayId($uniqueStayId = null)
    {
        // validation for constraint: int
        if (!is_null($uniqueStayId) && !(is_int($uniqueStayId) || ctype_digit($uniqueStayId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($uniqueStayId, true), gettype($uniqueStayId)), __LINE__);
        }
        $this->uniqueStayId = $uniqueStayId;
        return $this;
    }
    /**
     * Get pmark value
     * @return int
     */
    public function getPmark()
    {
        return $this->pmark;
    }
    /**
     * Set pmark value
     * @param int $pmark
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setPmark($pmark = null)
    {
        // validation for constraint: int
        if (!is_null($pmark) && !(is_int($pmark) || ctype_digit($pmark))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pmark, true), gettype($pmark)), __LINE__);
        }
        $this->pmark = $pmark;
        return $this;
    }
    /**
     * Get PMS_Flag value
     * @return int
     */
    public function getPMS_Flag()
    {
        return $this->PMS_Flag;
    }
    /**
     * Set PMS_Flag value
     * @param int $pMS_Flag
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setPMS_Flag($pMS_Flag = null)
    {
        // validation for constraint: int
        if (!is_null($pMS_Flag) && !(is_int($pMS_Flag) || ctype_digit($pMS_Flag))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pMS_Flag, true), gettype($pMS_Flag)), __LINE__);
        }
        $this->PMS_Flag = $pMS_Flag;
        return $this;
    }
    /**
     * Get isSolution value
     * @return int
     */
    public function getIsSolution()
    {
        return $this->isSolution;
    }
    /**
     * Set isSolution value
     * @param int $isSolution
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setIsSolution($isSolution = null)
    {
        // validation for constraint: int
        if (!is_null($isSolution) && !(is_int($isSolution) || ctype_digit($isSolution))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($isSolution, true), gettype($isSolution)), __LINE__);
        }
        $this->isSolution = $isSolution;
        return $this;
    }
    /**
     * Get HasCancelDynamicConditions value
     * @return bool
     */
    public function getHasCancelDynamicConditions()
    {
        return $this->HasCancelDynamicConditions;
    }
    /**
     * Set HasCancelDynamicConditions value
     * @param bool $hasCancelDynamicConditions
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setHasCancelDynamicConditions($hasCancelDynamicConditions = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasCancelDynamicConditions) && !is_bool($hasCancelDynamicConditions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hasCancelDynamicConditions, true), gettype($hasCancelDynamicConditions)), __LINE__);
        }
        $this->HasCancelDynamicConditions = $hasCancelDynamicConditions;
        return $this;
    }
    /**
     * Get uniqueStayIdTemp value
     * @return int
     */
    public function getUniqueStayIdTemp()
    {
        return $this->uniqueStayIdTemp;
    }
    /**
     * Set uniqueStayIdTemp value
     * @param int $uniqueStayIdTemp
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setUniqueStayIdTemp($uniqueStayIdTemp = null)
    {
        // validation for constraint: int
        if (!is_null($uniqueStayIdTemp) && !(is_int($uniqueStayIdTemp) || ctype_digit($uniqueStayIdTemp))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($uniqueStayIdTemp, true), gettype($uniqueStayIdTemp)), __LINE__);
        }
        $this->uniqueStayIdTemp = $uniqueStayIdTemp;
        return $this;
    }
    /**
     * Get uniqueStayIdTemp2 value
     * @return int
     */
    public function getUniqueStayIdTemp2()
    {
        return $this->uniqueStayIdTemp2;
    }
    /**
     * Set uniqueStayIdTemp2 value
     * @param int $uniqueStayIdTemp2
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setUniqueStayIdTemp2($uniqueStayIdTemp2 = null)
    {
        // validation for constraint: int
        if (!is_null($uniqueStayIdTemp2) && !(is_int($uniqueStayIdTemp2) || ctype_digit($uniqueStayIdTemp2))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($uniqueStayIdTemp2, true), gettype($uniqueStayIdTemp2)), __LINE__);
        }
        $this->uniqueStayIdTemp2 = $uniqueStayIdTemp2;
        return $this;
    }
    /**
     * Get ELC value
     * @return string|null
     */
    public function getELC()
    {
        return $this->ELC;
    }
    /**
     * Set ELC value
     * @param string $eLC
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setELC($eLC = null)
    {
        // validation for constraint: string
        if (!is_null($eLC) && !is_string($eLC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eLC, true), gettype($eLC)), __LINE__);
        }
        $this->ELC = $eLC;
        return $this;
    }
    /**
     * Get NS value
     * @return string|null
     */
    public function getNS()
    {
        return $this->NS;
    }
    /**
     * Set NS value
     * @param string $nS
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setNS($nS = null)
    {
        // validation for constraint: string
        if (!is_null($nS) && !is_string($nS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nS, true), gettype($nS)), __LINE__);
        }
        $this->NS = $nS;
        return $this;
    }
    /**
     * Get tac value
     * @return string|null
     */
    public function getTac()
    {
        return $this->tac;
    }
    /**
     * Set tac value
     * @param string $tac
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setTac($tac = null)
    {
        // validation for constraint: string
        if (!is_null($tac) && !is_string($tac)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tac, true), gettype($tac)), __LINE__);
        }
        $this->tac = $tac;
        return $this;
    }
    /**
     * Get spec value
     * @return string|null
     */
    public function getSpec()
    {
        return $this->spec;
    }
    /**
     * Set spec value
     * @param string $spec
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setSpec($spec = null)
    {
        // validation for constraint: string
        if (!is_null($spec) && !is_string($spec)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($spec, true), gettype($spec)), __LINE__);
        }
        $this->spec = $spec;
        return $this;
    }
    /**
     * Get crcChoosenOptions value
     * @return string|null
     */
    public function getCrcChoosenOptions()
    {
        return $this->crcChoosenOptions;
    }
    /**
     * Set crcChoosenOptions value
     * @param string $crcChoosenOptions
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setCrcChoosenOptions($crcChoosenOptions = null)
    {
        // validation for constraint: string
        if (!is_null($crcChoosenOptions) && !is_string($crcChoosenOptions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($crcChoosenOptions, true), gettype($crcChoosenOptions)), __LINE__);
        }
        $this->crcChoosenOptions = $crcChoosenOptions;
        return $this;
    }
    /**
     * Get mo value
     * @return string|null
     */
    public function getMo()
    {
        return $this->mo;
    }
    /**
     * Set mo value
     * @param string $mo
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setMo($mo = null)
    {
        // validation for constraint: string
        if (!is_null($mo) && !is_string($mo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mo, true), gettype($mo)), __LINE__);
        }
        $this->mo = $mo;
        return $this;
    }
    /**
     * Get OSmark value
     * @return string|null
     */
    public function getOSmark()
    {
        return $this->OSmark;
    }
    /**
     * Set OSmark value
     * @param string $oSmark
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setOSmark($oSmark = null)
    {
        // validation for constraint: string
        if (!is_null($oSmark) && !is_string($oSmark)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($oSmark, true), gettype($oSmark)), __LINE__);
        }
        $this->OSmark = $oSmark;
        return $this;
    }
    /**
     * Get bookingAlert value
     * @return string|null
     */
    public function getBookingAlert()
    {
        return $this->bookingAlert;
    }
    /**
     * Set bookingAlert value
     * @param string $bookingAlert
     * @return \StructType\SecureHolidayProductAvailabilitySpecifications
     */
    public function setBookingAlert($bookingAlert = null)
    {
        // validation for constraint: string
        if (!is_null($bookingAlert) && !is_string($bookingAlert)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bookingAlert, true), gettype($bookingAlert)), __LINE__);
        }
        $this->bookingAlert = $bookingAlert;
        return $this;
    }
}
